com.ihr.xbrl.om.table.structural

## Interface Aspect<T>

- Type Parameters:
    `T` - the generic type
  All Known Subinterfaces:
    ConceptAspectInterface, ConceptsAspectInterface, DimensionAspectInterface<T>, DimensionsAspectInterface<T>, EntityIdentifierAspectInterface, EntityIdentifiersAspectInterface, ExplicitDimensionAspectInterface, ExplicitDimensionsAspectInterface, PeriodAspectInterface, PeriodsAspectInterface, TypedDimensionAspectInterface, TypedDimensionsAspectInterface, UnitAspectInterface, UnitsAspectInterface
  All Known Implementing Classes:
    ConceptAspectNode, ConceptAspectRule, DimensionAspectNode, DimensionDefaultRule, DimensionExplicitRule, DimensionTypedRule, EntityIdentifierAspectNode, EntityIdentifierAspectRule, ExplicitDimensionAspectNode, NonXDTScenarioRuleSet, NonXDTSegmentRuleSet, OpenContextComponentRuleSet, PeriodAspectNode, PeriodAspectRule, TypedDimensionAspectNode, UnitAction, UnitAspectNode, UnitAspectRule, XBRLClosedRelationshipStructuralNode, XBRLConceptClosedRelationshipStructuralNode, XBRLDimensionClosedRelationshipStructuralNode

      public interface Aspect<T>

  This is a "mark" interface. it is used to indicate the marked class or interface is an aspect
  Author:
    Ignacio

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.Object` | `getAspectClashIdentity()` Returns an object that can be used to evaluate aspect clash.
    `int` | `getAspectType()` Returns a value from the CommonAspectRule class that identifies the aspect type.
    `T` | `getMember(XBRLStructuralTable table, CellHeader[] header)` Convert this aspect into a proper Member

- - ### Method Detail

    - #### getAspectClashIdentity

          java.lang.Object getAspectClashIdentity()

      Returns an object that can be used to evaluate aspect clash.
      Returns:
        the aspect clash identity

    - #### getAspectType

          int getAspectType()

      Returns a value from the CommonAspectRule class that identifies the aspect type.
      Returns:
        the aspect type

    - #### getMember

          T getMember(XBRLStructuralTable table,
                    CellHeader[] header)
                      throws XTValidationException

      Convert this aspect into a proper Member depending on the aspect type. Member can be used later to search for facts that satisfy the set of members
      Parameters:
        `table` - the table
        `header` - the header
      Returns:
        the member
      Throws:
        `XTValidationException` - the XT validation exception